package cn.ibizlab.core.rule.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.rule.domain.RuleEngine;
import cn.ibizlab.core.rule.filter.RuleEngineSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[RuleEngine] 服务对象接口
 */
public interface IRuleEngineService extends IService<RuleEngine> {

    boolean create(RuleEngine et);
    void createBatch(List<RuleEngine> list);
    boolean update(RuleEngine et);
    void updateBatch(List<RuleEngine> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    RuleEngine get(String key);
    RuleEngine getDraft(RuleEngine et);
    RuleEngine check(RuleEngine et);
    boolean checkBatch(List<RuleEngine> etList);
    boolean checkKey(RuleEngine et);
    RuleEngine cleanKC(RuleEngine et);
    boolean cleanKCBatch(List<RuleEngine> etList);
    RuleEngine run(RuleEngine et);
    boolean runBatch(List<RuleEngine> etList);
    boolean save(RuleEngine et);
    void saveBatch(List<RuleEngine> list);
    RuleEngine syncRun(RuleEngine et);
    boolean syncRunBatch(List<RuleEngine> etList);
    Page<RuleEngine> searchDefault(RuleEngineSearchContext context);
    List<RuleEngine> selectByModelId(String id);
    void removeByModelId(String id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


